//This function is needed to open a link in native browser
document.addEventListener("deviceready", onDeviceReady, false);
function onDeviceReady() {
    window.open = cordova.InAppBrowser.open;
}


var db = openDatabase('StudTest', '1.0', 'DB of StudTest', 2 * 1024 * 1024);
var globalVar = {};
globalVar['level'] = {id: null, name: null};
globalVar['class'] = {id: null, name: null};
globalVar['subject'] = {id: null, name: null};
globalVar['section'] = {id: null, name: null};
var current = 'level';
var questions = [];
var questionsAnswered = 0;

$(document).ready(function () {
    start();

    //Loading effect, when ajax is running
    $body = $("body");
    $(document).on({
        ajaxStart: function () {
            $body.addClass("loading");
        },
        ajaxStop: function () {
            $body.removeClass("loading");
        }
    });

});


function start() {
    $('#dynamicDiv').empty();
    $('#dynamicDiv').append('<div id="jumbo" class="jumbotron text-center">');
    $('#jumbo').append('<img src="images/logo.png" style="margin-bottom: 10px;">');
    $('#jumbo').append('<h3 style="color:#eea236">Når du trenger å friske opp pensum</h3>');
    $('#jumbo').append('<p><a class="btn btn-primary btn-xlg" style="width: 220px;" role="button" id="start"">START</a></p>');
    $('#jumbo').append('<p><a class="btn btn-lg" style="background-color: #f0ad4e; color: #ffffff; min-width: 220px;" role="button"  id="updatedb" >OPPDATER DATA</a></p>');
    $('#jumbo').append('<hr>');

    $('#jumbo').append('<p><a class="btn btn-success btn-lg" style="min-width: 220px;" role="button"  id="updatedb" onclick="window.open(\'http://folk.ntnu.no/gunaydin/\', \'_system\');">WEBAPP</a></p>');

    $("#updatedb").on('click', function () {
        var btn = $(this);
        btn.button('loading');
        loadDatabase(false);

        btn.button('reset');
    });

    $("#start").on('click', function () {
        getLevels();
    });

}


/**
 *  This function downloads the database from the server, and stores it locally on the device
 *  @param {boolean} start
 *  */
function loadDatabase(start) {
    $.ajax({
        url: 'http://folk.ntnu.no/gunaydin/feed.php',
        type: 'POST',
        data: {action: 'all'},
        dataType: 'JSON',
        timeout: 5000,
        success: function (data, status) {
            db.transaction(function (tx) {
                tx.executeSql('DROP TABLE IF EXISTS LEVEL');
                tx.executeSql('DROP TABLE IF EXISTS CLASS');
                tx.executeSql('DROP TABLE IF EXISTS SUBJECT');
                tx.executeSql('DROP TABLE IF EXISTS SECTION');
                tx.executeSql('DROP TABLE IF EXISTS QUESTION');
                tx.executeSql('DROP TABLE IF EXISTS ANSWER');

                tx.executeSql('CREATE TABLE IF NOT EXISTS LEVEL (id PRIMARY KEY UNIQUE, name)');
                tx.executeSql('CREATE TABLE IF NOT EXISTS CLASS (id PRIMARY KEY UNIQUE, name, level_id)');
                tx.executeSql('CREATE TABLE IF NOT EXISTS SUBJECT (id PRIMARY KEY UNIQUE, name, class_id)');
                tx.executeSql('CREATE TABLE IF NOT EXISTS SECTION (id PRIMARY KEY UNIQUE, name, subject_id)');
                tx.executeSql('CREATE TABLE IF NOT EXISTS QUESTION (id PRIMARY KEY UNIQUE, text, description, subject_id, section_id, user_id, date)');
                tx.executeSql('CREATE TABLE IF NOT EXISTS ANSWER (id PRIMARY KEY UNIQUE, text, correct, question_id)');

            });

            var values = "VALUES (";
            var query, rows = "";
            var val = [];
            for (var key in data) {
                var queryStart = "INSERT OR REPLACE INTO " + key.toUpperCase() + " (";
                var table = data[key];
                for (var i = 0; i < table.length; i++) {
                    var row = table[i];
                    for (var rowId in row) {
                        rows += rowId + ",";
                        values += "?,";
                        val.push(row[rowId]);
                    }
                    rows = rows.substr(0, rows.length - 1);
                    values = values.substr(0, values.length - 1);
                    var query = queryStart + rows + ") " + values + ")";
                    insert(query, val, data.length);
                    rows = "";
                    var values = "VALUES (";
                    val = [];
                }

            }
            $('#updatedb').text('Data har blitt oppdatert');
            $('#updatedb').attr('disabled', 'true');


            if (start)getLevels();

        },
        error: function (xhr, tStatus, err) {
            $('#dynamicDiv').empty();
            $('#dynamicDiv').append('<div id="jumbo" class="jumbotron text-center">');
            $('#jumbo').empty();
            $('#jumbo').append('<h3>Kunne ikke hente data</h3>');
            if (xhr.status == 0) {
                $('#jumbo').append('<p>Ingen tilkobling</p>');
            } else {
                $('#jumbo').append('<p>Det har oppstått en feil</p>');
            }
            $('#jumbo').append('<p><a class="btn btn-primary btn-lg" role="button" onclick="start();">Tilbake</a></p>');

        }
    });
}


/**
 *  Web SQL insert function
 */
function insert(sql, values, data) {
    db.transaction(function (tx) {
        tx.executeSql(sql, values, function (tx, result) {

            console.log('record added');
        }, onError);
    });

    return;
}


function onError() {
    console.log('Not added');

}


function nothingFound() {
    $('#dynamicDiv').append('<h2>Ingenting er registrert her</h2>');

}

/**
 * Appends html elements, and makes SQL query to get the buttons
 */
function getLevels() {

    $('#dynamicDiv').empty();


    $('#dynamicDiv').append('<div id="mainRow" class="row text-center">');
    $('#mainRow').append('<div id="mainPanel" class="panel panel-default text-center">');
    $('#mainPanel').append('<div id="panel-heading" class="panel-heading">');
    $('#mainPanel').append('<div id="panel-body" class="panel-body">');
    $('#mainPanel').append('<div class="panel-footer" id="panel-footer">');

    $('#panel-heading').append('<h3 class="panel-title" id="panel-title">Velg nivå</h3>');
    $('#panel-heading').append('<span class="btn-topleft" id="backbutton"></span>');
    $('#panel-body').append('<p>SETTER OPP NEDLASTET DATA <br>VENNLIGST VENT...</p>');

    $('#panel-footer').append('<h4>');


    db.transaction(queryDB);
}


/**
 * Appends the buttons, based on DB result
 * @param tx
 */
function queryDB(tx) {
    var sql = '';
    switch (current) {
        case 'level':
            sql = "SELECT * FROM LEVEL";
            break;
        case "class":
            sql = "SELECT class.id,class.name FROM class WHERE level_id='" + globalVar['level'].id + "'";
            break;
        case "subject":
            sql = "SELECT subject.id, subject.name FROM subject WHERE class_id='" + globalVar['class'].id + "'";
            break;
        case "section":
            sql = "SELECT section.id, section.name FROM section WHERE subject_id='" + globalVar['subject'].id + "'";
            break;
        case "question":
            getQuestionIds();
            return;
    }
    tx.executeSql(sql, [], querySuccess, queryError);
}

/**
 *
 * @param tx
 * @param results
 */
function querySuccess(tx, results) {
    var prevMenu = getNextMenu(false);
    var sname = '';
    if (prevMenu) {
        sname = globalVar[prevMenu].name;
    }
    $('#panel-footer h4').text(sname);


    var len = results.rows.length, i;
    $('#panel-body').empty();
    if (len == 0) {
        $('#panel-body').append('<h2>Ingenting funnet</h2>');
    } else {
        $("#panel-title").text(getHeader());
        $('#panel-body').append('<div class="list-group" id="' + current + '">');

        if (current == "section" && len > 1) {
            $('#' + current).append('<a class="list-group-item" style="border-bottom: solid;" value=" " id="-1">Alle</a>');
        }

        for (i = 0; i < len; i++) {
            var navn = results.rows.item(i)['name'];
            var id = results.rows.item(i)['id'];
            $('#' + current).append('<a class="list-group-item" value="' + navn + '" id="' + id + '">' + navn + '</a>');
        }

        $('#' + current + ' a').each(function () {
            var id = $(this).attr('id');
            var name = $(this).attr('value');
            $(this).click(function () {
                globalVar[current].id = id;
                globalVar[current].name = name;
                current = getNextMenu(true);
                db.transaction(queryDB);
            });
        });
    }
    $('#backbutton').empty();
    if (prevMenu) {
        $('#backbutton').append('<button class="btn btn-primary btn-lg" id="' + current + 'back">&laquo</button>');
        $('#' + current + 'back').on('click', function () {
            current = prevMenu;
            db.transaction(queryDB);
        });
    } else {
        $('#backbutton').append('<button class="btn btn-primary btn-lg" id="backtomain">&laquo</button>');
        $('#backtomain').on('click', function () {
            start();
        });

    }
}

function queryError(err) {
    console.log(err.code);
    $("#panel-title").text('Ingen data funnet på enheten. Du må laste ned oppgavene for å starte(krever internett tilkobling)');
    $('#panel-body').empty();
    $('#panel-body').append('<button type="button" class="btn btn-default btn-lg" id="updatedb"">Last ned oppgaver</button>');


    $('#backbutton').append('<button class="btn btn-primary btn-lg" id="backtomain">&laquo</button>');
    $('#backtomain').on('click', function () {
        start();
    });

    $("#updatedb").on('click', function () {
        var btn = $(this);
        btn.button('loading');
        loadDatabase(true);

    });

}

/**
 * Creates an array with the id's of the questions available in a given section.
 * Shuffles the array so that the questions comes in different order
 * @param {Number} section_id
 * */
function getQuestionIds(section_id) {
//            console.log(globalVar);
    var subject_id = globalVar['subject'].id;
    var section_id = globalVar['section'].id;
    var query = "Select id FROM question where subject_id='" + subject_id + "'";
    if (section_id != -1) {
        query += " AND section_id='" + section_id + "'";
    }
    $('#panel-body').empty();

    db.transaction(function (tx) {
        tx.executeSql(query, [], function (tx, results) {
            var len = results.rows.length, i;
            if (len == 0) {
                $('#panel-body').append('<h2>Ingen spørsmål funnet i denne kategorien.</h2>');
            } else {

                for (i = 0; i < len; i++) {
                    questions.push({
                        id: results.rows.item(i)['id'],
                        answered: false,
                        answerId: null,
                        correct: null,
                        description: null
                    });
                }

                questions = shuffle(questions);
                getQuestion(0);
            }
        }, null);
    });

}

/**
 *  Gets question in given index, and appends HTML elements for the question (text, alternatives),
 *  @param {Number} index
 */
function getQuestion(index) {
    db.transaction(function (tx) {
        tx.executeSql("SELECT  question.id as id, question.text, description, answer.text as ans, answer.id as aid, correct  FROM QUESTION, ANSWER WHERE question.id=question_id and question.id='" + questions[index].id + "'", [], function (tx, results) {
            var len = results.rows.length, i;
            $('#panel-body').empty();
            $('#underPanel').empty();
            $('#footer-content').empty();
            $('#footer-content-left').empty();
            $('#footer-content-right').empty();
            $('#footer').show(500);
            $('#navbar').hide();
            $('body').animate({paddingTop: '5px'});
            $('body').animate({paddingBottom: '55px'});

            var questionLength = questions.length;
            var startIndex;
            if (index < 2 || questionLength < 5) {
                startIndex = 0;
            } else if (questionLength > 4 && index == questionLength - 1) {
                startIndex = index - 4;
            } else if (questionLength > 4 && index == questionLength - 2) {
                startIndex = index - 3
            } else {
                startIndex = index - 2;
            }


            if (len == 0) {
                $('#panel-body').append('<h2>Ingen spørsmål funnet</h2>');
                return;
            } else {
                $('#panel-heading').empty();


                var id = results.rows.item(0)['id'];
                var question = results.rows.item(0)['text'];
                var description = results.rows.item(0)['description'];

                var questionNumber = (parseInt(index, 10) + 1);

                $('#panel-heading').append('<div class="panel-title"><strong class="pull-left" style="color:darkblue;">' + questionNumber + ')</strong> ' + question + '</div>');
                $('#panel-heading').attr('style', 'background-color:#97B7C9');


                $('#panel-body').append('<div class="list-group" id="alternatives">');

                var answers = [];
                for (var i = 0; i < len; i++) {
                    var answer = results.rows.item(i)['ans'];
                    var aid = results.rows.item(i)['aid'];
                    answers.push({answer: answer, aid: aid});
                }
                shuffle(answers);


                for (var i = 0; i < answers.length; i++) {
                    $('#alternatives').append('<a id="' + answers[i].aid + '" class="list-group-item">' + answers[i].answer + '</a>');
                }


                if (questions[index].answered) {
                    answerQuestion(id, index);
                } else {
                    $('#panel-body a').each(function () {
                        var answer_id = $(this).attr('id');
                        $(this).click(function () {
                            questions[index].answered = 1;
                            questions[index].answerId = answer_id;
                            questions[index].description = description;
                            answerQuestion(id, index);
                            questionsAnswered++;
                            $('#answeredAmount').text(questionsAnswered + ' av ' + questions.length + ' spørsmål besvart');
                            if (questionsAnswered == questions.length) {
                                $('#answeredAmount').text('ALLE SPØRSMÅL ER BESVART');

                            }

                        });
                    });
                }

                index = parseInt(index, 10);
                var place = parseInt(index, 10) + 1;
                var startPoint = (place - 2) > 0 ? place - 2 : 1;
                var i = 0;


                $('#panel-footer').empty();


                $('#panel-footer').append('<h4>');
                var section = globalVar['section'].name.toString();
                if (section != ' ') {
                    section = ' - ' + section;
                }
                var currentTest = globalVar['class'].name + ' - ' + globalVar['subject'].name + section;
                $('#panel-footer h4').text(currentTest);

                $('#panel-footer').append('<p style="font-size: 18px;" id="answeredAmount">' + questionsAnswered + ' av ' + questions.length + ' spørsmål besvart</p>');


                $('#panel-footer').append('<button class="btn btn-warning btn-lg"  style="width: 124px; " id="exit">AVSLUTT</button>');
                $('#panel-footer').append('<button class="btn btn-warning btn-lg"  style="margin-right:2px; width: 60px; display: none;" id="exitYes">JA</button>');
                $('#panel-footer').append('<button class="btn btn-info btn-lg"  style="margin-left:2px; width: 60px; display: none;" id="exitNo">NEI</button>');

                $("#exit").click(function () {
                    $('#exit, #exitYes, #exitNo').toggle(300);
                    $('#panel-footer h4').text('Avslutte?');
                    $('#exitText').toggle();
                });

                $("#exitYes").click(function () {
                    $('#underPanel').empty();
                    current = 'level';
                    calculateResult();

                });

                $("#exitNo").click(function () {
                    $('#exit, #exitYes, #exitNo').toggle(300);
                    $('#panel-footer h4').text(currentTest);
                    $('#exitText').toggle();

                });


                if (index != 0) {
                    $('#footer-content-left').append('<button type="button" style="color:#428bca; background-color:white; border-bottom-right-radius: 0; border-top-right-radius: 0;" id="prevQuestion" value="' + (index - 1) + '" class="btn btn-mxlg">&laquo</button>');
                    $('#prevQuestion').click(function () {
                        var id = $(this).attr('value');
                        getQuestion(id);
                    });
                }

                $('#footer-content').append('<ul id="navigation" class="pagination pagination-lg">');
                for (i = startIndex; i <= Math.min(questionLength - 1, (startIndex + 4)); i++) {
                    if (i == index) {
                        $("#navigation").append('<li class="active"><a href="#" id="' + i + '">' + (i + 1) + '</a></li>');
                    } else {
                        if (questions[i].answered) {
                            if (questions[i].correct)$("#navigation").append('<li><a style="background-color:#dff0d8;" href="#" id="' + i + '">' + (i + 1) + '</a></li>');
                            else $("#navigation").append('<li><a style="background-color:#f2dede;" href="#" id="' + i + '">' + (i + 1) + '</a></li>');
                        } else {
                            $("#navigation").append('<li><a href="#" id="' + i + '">' + (i + 1) + '</a></li>');
                        }
                    }
                }


                if (index != questions.length - 1) {
                    $('#footer-content-right').append('<button type="button" style="color:#428bca; background-color:white; border-bottom-left-radius: 0; border-top-left-radius: 0;" id="nextQuestion" value="' + (index + 1) + '" class="btn btn-mxlg">&raquo</button>');
                    $('#nextQuestion').click(function () {
                        var id = $(this).attr('value');
                        getQuestion(id);
                    });

                }


                $('#navigation li a').each(function () {
                    var id = $(this).attr('id');
                    $(this).click(function () {
                        getQuestion(id);
                    });
                });


            }

        }, null);
    });
}

/**
 * Run's when user answers question, and checks if it is correct or not
 * @param {Number} question_id
 * @param {Number} question_place
 */
function answerQuestion(question_id, questions_place) {
//            console.log(questions);
    db.transaction(function (tx) {
        tx.executeSql("SELECT id, correct FROM ANSWER where question_id='" + question_id + "'", [], function (tx, results) {
            var len = results.rows.length, i;
            var correctId = 0;
            questions[questions_place].correct = true;
            if (len == 0) {
                alert('Det har oppstått en feil.');
                start();
            } else {
                for (i = 0; i < len; i++) {
                    var id = results.rows.item(i)['id'];
                    var correct = results.rows.item(i)['correct'];
                    if (correct == 1) {
                        correctId = id;
                    }
                }
                var answer_id = questions[questions_place].answerId;
                if (answer_id != correctId) {
                    $('#' + answer_id).attr("class", "list-group-item list-group-item-danger");
                    questions[questions_place].correct = false;
                }
                $('#' + correctId).attr("class", "list-group-item list-group-item-success");

                var description = questions[questions_place].description;
                if (description != '') {
                    $('#dynamicDiv').append('<br>');
                    $('#panel-body').append('<div class="alert alert-info" role="alert">' + description + '</div>');
                }

                $('#alternatives a').each(function () {
                    $(this).unbind('click');
                });

            }

        }, null);
    });
}

/**
 * Calculates test results when it is finished
 */

function calculateResult() {
    questionsAnswered = 0;
    var question_total = questions.length;
    var answered = 0;
    var correct = 0;
    for (var i = 0; i < question_total; i++) {
        var question = questions[i];
        if (question.answered) {
            answered++;
            question.answered = null;
            if (question.correct)correct++;
        }

    }


    $('#panel-heading').empty();
    $('#panel-heading').append('<div class="panel-title">RESTULTAT</div>');
    $('#panel-body').empty();


    $('#panel-body').append('<div class="progress" id="resultProgress">');

    var percent = Math.floor(100 * (correct / question_total));
    percent = parseInt(percent);
    var progresType = '';
    if (0 <= percent && percent < 25) {
        progresType = 'progress-bar-danger';
    }
    else if (25 <= percent && percent < 50) {
        progresType = 'progress-bar-warning';
    }
    else if (50 <= percent && percent < 99) {
        progresType = 'progress-bar-info';
    }
    else {
        progresType = 'progress-bar-success';
    }

    $('#resultProgress').append('<div class="progress-bar ' + progresType + '" role="progressbar" ' +
    'aria-valuenow="' + percent + '" aria-valuemin="0" aria-valuemax="100" style="width: ' + percent + '%;"><span>' + percent + '%</span></div>');

    $('#panel-body').append('<h3>Du svarte på ' + answered + ' spørsmål, av ' + question_total + ' totalt.</h3>');
    $('#panel-body').append('<h3>Av disse fikk du  ' + correct + ' riktig(e)</h3>');


    $('#panel-footer').empty();
    $('#footer').hide();
    $('#navbar').show();
    $('body').animate({paddingTop: '70px'});


    $('#panel-footer').append('<p><a class="btn btn-info btn-lg"  style="width: 210px;" role="button" id="retry"">PRØV IGJEN</a></p>');
    $('#panel-footer').append('<p><a class="btn btn-warning btn-lg" style="width: 210px;" role="button" id="restart"">AVSLUTT</a></p>');


    $("#restart").on('click', function () {
        questions = [];
        start();
    });

    $("#retry").on('click', function () {
        $('#dynamicDiv').empty();

        $('#dynamicDiv').append('<div id="mainRow" class="row text-center">');
        $('#mainRow').append('<div id="mainPanel" class="panel panel-default text-center">');
        $('#mainPanel').append('<div id="panel-heading" class="panel-heading">');
        $('#mainPanel').append('<div id="panel-body" class="panel-body">');
        $('#mainPanel').append('<div class="panel-footer" id="panel-footer">');

        $('#panel-heading').append('<div class="panel-title" id="panel-title">Velg Nivå</div>');
        $('#panel-heading').append('<span class="btn-topleft" id="backbutton"></span>');

        $('#panel-footer').append('<h4>');

        getQuestion(0);
    });


}


/**
 * Helper function. Shuffles the array
 * @param {Array} array
 */
function shuffle(array) {
    var tmp, current, top = array.length;

    if (top) while (--top) {
        current = Math.floor(Math.random() * (top + 1));
        tmp = array[current];
        array[current] = array[top];
        array[top] = tmp;
    }

    return array;
}

/**
 * Helper function. Get name of the next or previous menu
 * @param {Boolean} next
 * @returns {*}
 */
function getNextMenu(next) {
    switch (current) {
        case "level":
            if (next)return "class";
            else return null;
        case "class":
            if (next)return "subject";
            else return "level";
        case "subject":
            if (next)return "section";
            else return "class";
        case "section":
            if (next)return "question";
            else return "subject";
    }

}

/**
 * Helper functions. gives the text to be shown on the header.
 * @returns {string}
 */
function getHeader() {
    switch (current) {
        case "level":
            return 'Velg nivå';
        case "class":
            return 'Velg klasse';
        case "subject":
            return 'Velg fag';
        case "section":
            return 'Velg tema';

    }
}
