

var globalVar = {};
globalVar['level'] = {id: null, name: null};
globalVar['class'] = {id: null, name: null};
globalVar['subject'] = {id: null, name: null};
globalVar['section'] = {id: null, name: null};
globalVar['question'] = {id: null, name: null};
var current = 'level';
var questions = [];
var questionsAnswered = 0;

$(document).ready(function () {

    $("#includedContent").load("navbar.html");

    start();

    //loading animation
    $body = $("body");
    $(document).on({
        ajaxStart: function() { $body.addClass("loading"); },
        ajaxStop: function() { $body.removeClass("loading"); }
    });

});


function start() {
    $('#dynamicDiv').empty();
    $('#dynamicDiv').append('<div id="jumbo" class="jumbotron text-center">');
    $('#jumbo').append('<img src="images/logo.png" style="margin-bottom: 10px;">');
    $('#jumbo').append('<h3 style="color:#eea236">Når du trenger å friske opp pensum</h3>');
    $('#jumbo').append('<p><a class="btn btn-primary btn-xlg" style="width: 220px;" role="button" id="start"">START</a></p>');
    $('#jumbo').append('<p><a class="btn btn-success btn-lg"  style="width: 220px;" role="button" id="admin">Lag dine egne spørsmål</a></p>');


    $("#start").on('click', function () {
        getLevels();
    });


    $("#admin").on('click', function () {
        window.location.href = 'http://folk.ntnu.no/gunaydin/admin/';
    });

}


function onError() {
    //console.log('Not added');

}

function nothingFound() {
    $('#dynamicDiv').append('<h2>Ingenting er registrert her</h2>');


}

/**
 * Appends html elements, and makes SQL query to get the buttons
 */
function getLevels() {
    $('#dynamicDiv').empty();


    $('#dynamicDiv').append('<div id="mainRow" class="row text-center">');
    $('#mainRow').append('<div id="mainPanel" class="panel panel-default text-center">');
    $('#mainPanel').append('<div id="panel-heading" class="panel-heading">');
    $('#mainPanel').append('<div id="panel-body" class="panel-body">');
    $('#mainPanel').append('<div class="panel-footer" id="panel-footer">');

    $('#panel-heading').append('<h3 class="panel-title" id="panel-title">Velg Nivå</h3>');
    $('#panel-heading').append('<span class="btn-topleft" id="backbutton"></span>');

    $('#panel-footer').append('<h4>');


    queryDB();
}


/**
 * Appends the buttons, based on DB result
 */
function queryDB() {
    var sql = '';
    var id = -1;
    var secondid = -1;
    switch (current) {
        case "class":
            id = globalVar['level'].id;
            break;
        case "subject":
            id = globalVar['class'].id;
            break;
        case "section":
            id = globalVar['subject'].id;
            break;
        case "question":
            id = globalVar['subject'].id;
            secondid = globalVar['section'].id;
            break;

    }

    $.ajax({
        url: 'http://folk.ntnu.no/gunaydin/feed.php',
        type: 'POST',
        data: {action: current, id: id, secondid: secondid},
        dataType: 'JSON',
        timeout: 5000,
        success: successFunction,
        error: errorFunction
    });
}

/**
 * Ajax success function, this functions displays the results from the DB
 * @param data
 */
function successFunction(data) {
  //  console.log(current);
    var prevMenu = getNextMenu(false);
    if(prevMenu){
        $('#panel-footer h4').text(globalVar[prevMenu].name);

    }
    if (current == 'question') {
        if (questions.length == 0) {
            if (data.length == 0) {
                current = 'section';
                alert("Det er ingen spørsmål lagret i denne kategorien. Husk, du kan selv lage spørsmål!");
                return;
            } else {
                //console.log("returnedData",data);
                for (var i = 0; i < data.length; i++) {
                    questions.push({id: data[i].id, answered: false, answerId: null, correct: null, description: null});
                }

                questions = shuffle(questions);
                getQuestion(0);
                return;
            }
        } else {

        }
    } else if (current != 'question') {
       // console.log(data);
       // console.log(globalVar);

        if (data.length == 0) {
            alert("Her er det tomt. Husk, du kan selv lage spørsmål til denne kategorien :)");
            current = getNextMenu(false);
            return;
        } else {
            $('#panel-body').empty();
            $("#panel-title").text(getHeader());
            $('#panel-body').append('<div class="list-grop" id="' + current + '">');

            if (current == "section" && data.length>1) {
                $('#' + current).append('<a class="list-group-item" style="border-bottom: solid;" value=" " id="-1">Alle</a>');
            }

            for (var i = 0; i < data.length; i++) {
                var navn = data[i].name;
                var id = data[i].id;
                $('#' + current).append('<a class="list-group-item" value="' + navn + '" id="' + id + '">' + navn + '</a>');
            }

            $('#' + current + ' a').each(function () {
                var id = $(this).attr('id');
                var name = $(this).attr('value');
                $(this).click(function () {
                    globalVar[current].id = id;
                    globalVar[current].name = name;
                    current = getNextMenu(true);
                    queryDB();
                });
            });
        }
        $('#backbutton').empty();
        var prevMenu = getNextMenu(false);
        if (prevMenu) {
            $('#backbutton').append('<button class="btn btn-primary btn-lg" id="' + current + 'back">&laquo</button>');
            $('#' + current + 'back').on('click', function () {
                current = prevMenu;
                queryDB();
            });
        } else {
            $('#backbutton').append('<button class="btn btn-primary btn-lg" id="backtomain">&laquo</button>');
            $('#backtomain').on('click', function () {
                start();
            });

        }

    }

}

/**
 * Ajax error function
 */
function errorFunction() {
    alert("A connection error happened");
    window.location.href = 'http://folk.ntnu.no/gunaydin/';
}


/**
 * Get question from DB, and append HTML elements (
 * @param index
 */
function getQuestion(index) {
    $.ajax({
        url: 'http://folk.ntnu.no/gunaydin/feed.php',
        type: 'POST',
        data: {action: 'getquestion', id: questions[index].id},
        dataType: 'JSON',
        timeout: 5000,
        success: function (data, status) {
            var len = data.length;
            $('#panel-body').empty();
            $('#underPanel').empty();
            $('#footer-content').empty();
            $('#footer-content-left').empty();
            $('#footer-content-right').empty();
            $('#footer').show(500);
            $('#navbar').hide();
            $('body').animate({paddingTop: '5px'});
            $('body').animate({paddingBottom: '55px'});

            var questionLength = questions.length;
            var startIndex;
            if(index<2 || questionLength<5){
                startIndex=0;
            } else if(questionLength>4&&index==questionLength-1) {
                startIndex = index - 4;
            } else if(questionLength>4&&index==questionLength-2){
                startIndex=index-3
            } else{
                startIndex= index-2;
            }

        //    console.log("SI", startIndex, "QL", questionLength);

            if (len == 0) {
                $('#panel-body').append('<h2>Ingen spørsmål funnet</h2>');
                return;
            } else {
                $('#panel-heading').empty();


                var id = data[0].id;
                var question = data[0].text;
                var description = data[0].description;

                var questionNumber = (parseInt(index, 10) + 1);

                $('#panel-heading').append('<div class="panel-title"><strong class="pull-left" style="color:darkblue;">' + questionNumber + ')</strong> ' + question + '</div>');
                $('#panel-heading').attr('style', 'background-color:#97B7C9');


                $('#panel-body').append('<div class="list-group" id="alternatives">');

                var answers = [];
                for (var i = 0; i < len; i++) {
                    var answer = data[i].ans;
                    var aid = data[i].aid;
                    answers.push({answer:answer, aid:aid});
                }
                shuffle(answers);

                for(var i =0; i<answers.length; i++){
                    $('#alternatives').append('<a id="' + answers[i].aid + '" class="list-group-item">' + answers[i].answer + '</a>');
                }


                if (questions[index].answered) {
                    answerQuestion(id, index);
                } else {
                    $('#panel-body a').each(function () {
                        var answer_id = $(this).attr('id');
                        $(this).click(function () {
                            questions[index].answered = 1;
                            questions[index].answerId = answer_id;
                            questions[index].description = description;
                            answerQuestion(id, index);
                            questionsAnswered++;
                            $('#answeredAmount').text(questionsAnswered + ' av '+questionLength+' spørsmål besvart');
                        });
                    });
                }

                index = parseInt(index, 10);
                var place = parseInt(index, 10) + 1;
                var startPoint = (place - 2) > 0 ? place - 2 : 1;
                var i = 0;


                $('#panel-footer').empty();


                $('#panel-footer').append('<h4>');
                var section = globalVar['section'].name.toString();
                if (section != ' ') {
                    section = ' - ' + section;
                }
                var currentTest = globalVar['class'].name + ' - ' + globalVar['subject'].name + section;
                $('#panel-footer h4').text(currentTest);

                $('#panel-footer').append('<p style="font-size: 18px;" id="answeredAmount">'+questionsAnswered+' av '+questionLength+' spørsmål besvart</p>');


                $('#panel-footer').append('<button class="btn btn-warning btn-lg"  style="width: 124px; " id="exit">AVSLUTT</button>');
                $('#panel-footer').append('<button class="btn btn-warning btn-lg"  style="margin-right:2px; width: 60px; display: none;" id="exitYes">JA</button>');
                $('#panel-footer').append('<button class="btn btn-info btn-lg"  style="margin-left:2px; width: 60px; display: none;" id="exitNo">NEI</button>');

                $("#exit").click(function () {
                    $('#exit, #exitYes, #exitNo').toggle(300);
                    $('#panel-footer h4').text('Avslutte?');
                    $('#exitText').toggle();
                });

                $("#exitYes").click(function () {
                    $('#underPanel').empty();
                    current = 'level';
                    calculateResult();

                });

                $("#exitNo").click(function () {
                    $('#exit, #exitYes, #exitNo').toggle(300);
                    $('#panel-footer h4').text(currentTest);
                    $('#exitText').toggle();

                });


                if (index != 0) {
                    $('#footer-content-left').append('<button type="button" style="color:#428bca; background-color:white; border-bottom-right-radius: 0; border-top-right-radius: 0;" id="prevQuestion" value="' + (index - 1) + '" class="btn btn-mxlg">&laquo</button>');
                    $('#prevQuestion').click(function () {
                        var id = $(this).attr('value');
                        getQuestion(id);
                    });
                }


                $('#footer-content').append('<ul id="navigation" class="pagination pagination-lg">');

                for(i=startIndex; i<=Math.min(questionLength-1,(startIndex+4)); i++){
                    if (i == index ) {
                        $("#navigation").append('<li class="active"><a href="#" id="'+i+'">' + (i+1) + '</a></li>');
                    } else {
                        if (questions[i].answered) {
                            if (questions[i].correct)$("#navigation").append('<li><a style="background-color:#dff0d8;" href="#" id="' + i  + '">' + (i+1) + '</a></li>');
                            else $("#navigation").append('<li><a style="background-color:#f2dede;" href="#" id="' + i + '">' + (i+1) + '</a></li>');
                        } else {
                            $("#navigation").append('<li><a href="#" id="' + i   + '">' + (i+1) + '</a></li>');
                        }
                    }
                }




                if (index != questions.length - 1) {
                    $('#footer-content-right').append('<button type="button" style="color:#428bca; background-color:white; border-bottom-left-radius: 0; border-top-left-radius: 0;" id="nextQuestion" value="' + (index + 1) + '" class="btn btn-mxlg">&raquo</button>');
                    $('#nextQuestion').click(function () {
                        var id = $(this).attr('value');
                        getQuestion(id);
                    });

                }


                $('#navigation li a').each(function () {
                    var id = $(this).attr('id');
                    $(this).click(function () {
                        getQuestion(id);
                    });
                });

            }

        },
        error: errorFunction
    });

}

/**
 * Run's when user answers question, and checks if it is correct or not
 * @param {Number} question_id
 * @param {Number} question_place
 */
function answerQuestion(question_id, questions_place) {
    $.ajax({
        url: 'http://folk.ntnu.no/gunaydin/feed.php',
        type: 'POST',
        data: {action: 'answer', id: question_id},
        dataType: 'JSON',
        timeout: 5000,
        success: function (data, status) {
       //     console.log(data);
            var len = data.length;
            var correctId = 0;
            questions[questions_place].correct = true;
            if (len == 0) {
          //      console.log(len);
            } else {
                for (var i = 0; i < len; i++) {
                    var id = data[i].id
                    var correct = data[i].correct;
                    if (correct == 1) {
                        correctId = id;
                    }
                }
                var answer_id = questions[questions_place].answerId;
                if (answer_id != correctId) {
                    $('#' + answer_id).attr("class", "list-group-item list-group-item-danger");
                    questions[questions_place].correct = false;
                }
                $('#' + correctId).attr("class", "list-group-item list-group-item-success");

                var description = questions[questions_place].description;
                if (description != '') {
                    $('#dynamicDiv').append('<br>');
                    $('#panel-body').append('<div class="alert alert-info" role="alert">' + description + '</div>');
                }

                $('#alternatives a').each(function () {
                    $(this).unbind('click');
                });

            }

        },
        error: errorFunction
    });
}

/**
 * Calculates test results when it is finished
 */
function calculateResult() {
    questionsAnswered = 0;
    var question_total = questions.length;
    var answered = 0;
    var correct = 0;
    for (var i = 0; i < question_total; i++) {
        var question = questions[i];
        if (question.answered) {
            answered++;
            question.answered = null;
            if (question.correct)correct++;
        }

    }

   // console.log(question_total, answered, correct);

    $('#panel-heading').empty();
    $('#panel-heading').append('<div class="panel-title">RESTULTAT</div>');
    $('#panel-body').empty();


$('#panel-body').append('<div class="progress" id="resultProgress">');

    var percent = Math.floor(100*(correct/question_total));
    percent = parseInt(percent);
    var progresType = '';
    if(0<=percent && percent<25){
        progresType='progress-bar-danger';
    }
    else if(25<=percent && percent<50){
        progresType='progress-bar-warning';
    }
    else if(50<=percent && percent<99){
        progresType='progress-bar-info';
    }
    else {
        progresType='progress-bar-success';
    }

    $('#resultProgress').append('<div class="progress-bar '+progresType+'" role="progressbar" ' +
    'aria-valuenow="'+percent+'" aria-valuemin="0" aria-valuemax="100" style="width: '+percent+'%;"><span>'+percent+'%</span></div>');

    $('#panel-body').append('<h3>Du svarte på '+answered+' spørsmål, av '+ question_total+' totalt.</h3>');
    $('#panel-body').append('<h3>Av disse fikk du  ' + correct + ' riktig(e)</h3>');


    $('#panel-footer').empty();
    $('#footer').hide();
    $('#navbar').show();
    $('body').animate({paddingTop: '70px'});


    $('#panel-footer').append('<p><a class="btn btn-info btn-lg"  style="width: 210px;" role="button" id="retry"">PRØV IGJEN</a></p>');
    $('#panel-footer').append('<p><a class="btn btn-warning btn-lg" style="width: 210px;" role="button" id="restart"">AVSLUTT</a></p>');


    $("#restart").on('click', function () {
        questions = [];
        start();
    });

    $("#retry").on('click', function () {
        $('#dynamicDiv').empty();

        $('#dynamicDiv').append('<div id="mainRow" class="row text-center">');
        $('#mainRow').append('<div id="mainPanel" class="panel panel-default text-center">');
        $('#mainPanel').append('<div id="panel-heading" class="panel-heading">');
        $('#mainPanel').append('<div id="panel-body" class="panel-body">');
        $('#mainPanel').append('<div class="panel-footer" id="panel-footer">');

        $('#panel-heading').append('<div class="panel-title" id="panel-title">Velg Nivå</div>');
        $('#panel-heading').append('<span class="btn-topleft" id="backbutton"></span>');

        $('#panel-footer').append('<h4>');
//            $('#mainRow').append('<div id="underPanel" class="text-center">');


        getQuestion(0);
    });


}

/**
 * Helper function. Get name of the next or previous menu
 * @param {Boolean} next
 * @returns {*}
 */
function getNextMenu(next) {
    switch (current) {
        case "level":
            if (next)return "class";
            else return null;
        case "class":
            if (next)return "subject";
            else return "level";
        case "subject":
            if (next)return "section";
            else return "class";
        case "section":
            if (next)return "question";
            else return "subject";
    }

}

/**
 * Helper functions. gives the text to be shown on the header.
 * @returns {string}
 */
function getHeader() {
    switch (current) {
        case "level":
            return 'Velg nivå';
        case "class":
            return 'Velg klasse';
        case "subject":
            return 'Velg fag';
        case "section":
            return 'Velg tema';

    }
}

/**
 * Helper function. Shuffles the array
 * @param {Array} array
 */
function shuffle(array) {
    var tmp, current, top = array.length;

    if (top) while (--top) {
        current = Math.floor(Math.random() * (top + 1));
        tmp = array[current];
        array[current] = array[top];
        array[top] = tmp;
    }

    return array;
}