$(document).ready(function () {

    $("#includedContent").load("../navbar.html");


    $('#save-question').click(function () {
        validator();
    });

    $('#back-button').click(function () {
        window.location.href = 'http://folk.ntnu.no/gunaydin/';
    });

    $('.dropdown-menu').find('input').click(function (e) {
        e.stopPropagation();
    });

    queryDB();

});
var alternatives = [5, 4, 3];


var current = 'level';
var globalVar = {};
globalVar['level'] = {id: null, name: null};
globalVar['class'] = {id: null, name: null};
globalVar['subject'] = {id: null, name: null};
globalVar['section'] = {id: null, name: null};


/**
 * Gets data from DB
 */
function queryDB() {
    var id = -1;
    switch (current) {
        case "class":
            id = globalVar['level'].id;
            break;
        case "subject":
            id = globalVar['class'].id;
            break;
        case "section":
            id = globalVar['subject'].id;
            break;
        case "question":
            id = globalVar['subject'].id;
            secondid = globalVar['section'].id;
            break;

    }

    $.ajax({
        url: 'http://folk.ntnu.no/gunaydin/feed.php',
        type: 'POST',
        data: {action: current, id: id},
        dataType: 'JSON',
        timeout: 5000,
        success: successFunction,
        error: errorFunction
    });
}


/**
 * Ajax success function, handles the menu and the panel
 * @param data
 */
function successFunction(data) {

    var next = getNextMenu(current);

    $("#" + current).empty();
    $("#" + next).empty();

    if (current != 'level') {
        var tmpCurrent = current;
        while (tmpCurrent != false) {
            $("#" + tmpCurrent).empty();
            tmpCurrent = getNextMenu(tmpCurrent);
        }

    }


    var buttonName = getButtonName(current);
    $("#" + current).append('<button class="btn btn-default btn-lg dropdown-toggle" type="button" value="' + current + '" id="' + current + 'dropdownMenu" data-toggle="dropdown" style="min-width:100px;">' +
    buttonName + '<span class="caret"></span></button>');

    $("#" + current).append('<ul id="' + current + 'dropdownItems" class="dropdown-menu" role="menu" aria-labelledby="' + current + 'dropdownMenu">');




        for (var i = 0; i < data.length; i++) {
            var navn = data[i].name;
            var id = data[i].id;
            $("#" + current + "dropdownItems").append('<li role="presentation"><a role="menuitem" tabindex="-1" value="' + navn + '" id="' + id + '">' + navn + '</a></li>');
        }



        $('#' + current + 'dropdownMenu').click(function () {
            current = $(this).attr('value');

        });




    if (current != 'level') {
        if(data.length==0)$("#" + current + "dropdownItems").append('<li role="presentation" class="dropdown-header">Ingen '+buttonName.toLowerCase()+' funnet</li>');

        $("#" + current + "dropdownItems").append('<li role="presentation" class="divider"></li>');
        $("#" + current + "dropdownItems").append('<li role="presentation" id="addnew' + current + '"><a role="menuitem" tabindex="-1" value="Legg" id="add' + current + '">+ Legg til ny</a></li>');
    }


    $('#' + current + 'dropdownItems a').each(function () {
        var id = $(this).attr('id');
        var name = $(this).attr('value');
        $(this).click(function (e) {

            if (id != 'add' + current) {
                if (current != 'section') {
                    $('#questionform').hide();
                    var previi = getNextMenu(current);
                    $('#jumbo-heading').text('Velg ' + getButtonName(previi).toLowerCase());
                    $('#jumbo-heading').show(250);
                    $('#save-question').hide(250);
                    $('#' + current + 'dropdownMenu').html(name + '<span class="caret"></span>');
                    globalVar[current].id = id;
                    current = getNextMenu(current);
                    queryDB();
                } else {
                    $('#' + current + 'dropdownMenu').html(name + '<span class="caret"></span>');
                    globalVar[current].id = id;
                    $('#jumbo-heading').hide();
                    appendQuestionForm();
                    $('#message-box').hide();
                    $('#questionform').show(250);
                }
            } else {
                e.stopPropagation();
                $("#addnew" + current).empty();
                $("#addnew" + current).append('<div class="input-group" id="new' + current + '">');
                $('#new' + current).append('<input type="text" class="form-control" placeholder="Skriv '+buttonName.toLowerCase()+' navn">');
                $('#new' + current).append('<span class="input-group-btn"><button class="btn btn-info" type="button" id="add-new' + current + '-button">+</button></span>');

                $('.dropdown-menu').find('input').click(function (e) {
                    e.stopPropagation();
                });

                $('#add-new' + current + '-button').click(function () {
                    var prev = getPrevMenu(current);
                    id = globalVar[prev].id;
                    var newName = $('#new' + current).find('input').val();
                    $.ajax({
                        url: 'http://folk.ntnu.no/gunaydin/feed.php',
                        type: 'POST',
                        data: {action: 'insert', category: current, id: id, name: newName},
                        dataType: 'JSON',
                        timeout: 5000,
                        success: function (data) {  
                            queryDB();
                        },
                        error: function (data) {

                        }
                    });


                });


            }
        });


    });


}


function errorFunction() {


}

/**
 * Adds an answer alternative text field to the questionform.
 */
function addAlternative() {
    //  console.log(alternatives);
    if (alternatives.length > 0) {
        var index = alternatives.pop();
        $('#alternatives').append('<div class="input-group" id="alt' + index + '" style="margin-top: 5px;">');
        $('#alt' + index).append('<span class="input-group-addon"><input type="radio" name="options" id="alt' + index + 'opt"></span>');
        $('#alt' + index).append('<input type="text" class="form-control" id="alt' + index + 'text" placeholder="Svaralternativ ' + index + '">');
        $('#alt' + index).append('<span class="input-group-btn"><button class="btn btn-danger" type="button" data-toggle="tooltip" data-placement="bottom" title="Fjern alternativ" id="alt' + index + 'delete">X</button></span>');


        $('#alt' + index + 'delete').click(function () {
            alternatives.push(index);
            $('#alt' + index).remove();
        });
    }
}

/**
 * Validates the question form, and adds the question to the DB if valid
 */
function validator() {
    var subject = globalVar['subject'].id;
    var section = globalVar['section'].id;
    var questionText = $.trim($('#question-text').val());
    var description = $('#description').val();
    var radioCheck = false;
    var alternativesCheck = true;
    var alternativeWithError = null;

    var alternatives = [];

    $('#alternatives div').each(function () {
        var correct = $(this).find("input[type=radio]:checked").val();
        var text = $(this).find("input[type=text]").val();
        if (correct) {
            radioCheck = true;
            correct = 1;
        } else {
            correct = 0;
        }
        alternatives.push({text: text, correct: correct});
        if (text == '') {
            alternativesCheck = false;
            alternativeWithError = $(this).find("input[type=text]");
            return false;
        }
        $(this).find("input[type=text]").css('background-color', '');
        $('#question-text').css('background-color', '');

    });


    $('#message-box').attr('class', 'alert alert-warning');
    if (!subject) {
        $('#message-box').text('Du må velge et fag');
    } else if (!section) {
        $('#message-box').text('Du må velge et tema');
    } else if (!questionText) {
        $('#message-box').text('Oppgaveteksten kan ikke være tom');
    } else if (!alternativesCheck) {
        $('#message-box').text('Svaralternativene kan ikke være tomme');
    } else if (!radioCheck) {
        $('#message-box').text('Et av svarene må være riktig, huk svaralternativet som er riktig');
    } else {
        //  console.log(alternatives, subject, section, questionText, description);

        var questionObject = {
            subject: subject,
            section: section,
            question: questionText,
            description: description,
            userid: userid,
            alternatives: alternatives
        };


        $.ajax({
            url: 'http://folk.ntnu.no/gunaydin/feed.php',
            type: 'POST',
            data: {action: 'insertquestion', questions: JSON.stringify(questionObject)},
            dataType: 'JSON',
            timeout: 5000,
            success: function (data) {
                $('#message-box').attr('class', 'alert alert-info');
                $('#message-box').text('Oppgaven er lagret');
                appendQuestionForm();
                $('#questionform').show(250);
                $('#message-box').fadeOut(5000);

            },
            error: function (data) {
                alert('ikke da');

            }
        });


    }

    $('#message-box').show(250);


}


/**
 * Appends the form
 */
function appendQuestionForm() {
    $('#jumbo').html('<h3 class="text-center" id="jumbo-heading"></h3>' +
    '<div id="questionform" style="display: none;">' +
    '<div class="input-group input-group-lg">' +
    '<input type="text" class="form-control" id="question-text" placeholder="Oppgavetekst">' +
    '<span class="input-group-addon">?</span></div>' +
    '<div data-toggle="input" style="margin-top: 20px;" id="alternatives">' +
    '<div class="input-group" id="alt1" style="margin-top: 5px;"><span class="input-group-addon">' +
    '<input type="radio" name="options" id="alt1opt"></span><input type="text" class="form-control" id="alt1text" placeholder="Svaralternativ 1"></div>' +
    '<div class="input-group" id="alt2" style="margin-top: 5px;"><span class="input-group-addon"><input type="radio" name="options" id="alt2opt"></span>' +
    '<input type="text" class="form-control" id="alt2text" placeholder="Svaralternativ 2"></div></div>' +
    '<button class="btn btn-info btn-lg btn-block" role="button" style="margin-top: 5px;" id="add-new-alt" data-toggle="tooltip" data-placement="bottom" title="Legg til et nytt alternativ">+</button>' +
    '<div class="input-group input-group-lg" style="margin-top: 25px;"><span class="input-group-addon">*</span>' +
    '<input type="text" class="form-control" placeholder="Forklaring (valgfritt)" id="description"></div><i>*Forklaringsteksten vises etter at spørsmållet er besvart</i></div>');
    alternatives = [5, 4, 3];
    $('#add-new-alt').click(function () {
        addAlternative();
    });
    $('#save-question').show(100);
}


/**
 * Help function
 * @param current
 * @returns {string}
 */
function getButtonName(current) {
    switch (current) {
        case 'level':
            return 'Nivå';
        case 'class':
            return 'Klasse';
        case 'subject':
            return 'Fag';
        case 'section':
            return 'Tema';
    }
}

/**
 * Help function
 * @param current
 * @returns {*}
 */
function getNextMenu(current) {
    switch (current) {
        case "level":
            return "class";
        case "class":
            return "subject";
        case "subject":
            return "section";
        case "section":
            return false;
    }

}

/**
 * Help function
 * @param current
 * @returns {*}
 */
function getPrevMenu(current) {
    switch (current) {
        case "class":
            return "level";
        case "subject":
            return "class";
        case "section":
            return "subject";
        case "level":
            return false;
    }

}


      
